%define major		3
%define libname		%mklibname %{name} %{major}
%define develname	%mklibname %{name} -d

Name:		olm
Version:	3.2.16
Release:	%mkrel 3
Summary:	Double Ratchet cryptographic library
License:	ASL 2.0
Group:		System/Libraries
URL:		https://gitlab.matrix.org/matrix-org/olm
Source0:	https://gitlab.matrix.org/matrix-org/olm/-/archive/%{version}/%{name}-%{version}.tar.bz2
Patch0:		olm-cmake-4.0.patch

BuildRequires:	ninja-build
BuildRequires:	cmake

BuildRequires:	pkgconfig(python3)
BuildRequires:	python3dist(setuptools)
BuildRequires:	python3dist(cffi)
BuildRequires:	python3dist(future)

%description
An implementation of the Double Ratchet cryptographic ratchet in C++.

#------------------------------------------------

%package -n	%{libname}
Summary:	Double Ratchet cryptographic library
Group:		System/Libraries

%description -n	%{libname}
An implementation of the Double Ratchet cryptographic ratchet in C++.

#------------------------------------------------

%package -n	%{develname}
Summary:	Development package for %{name}
Group:		Development/C++
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n %{develname}
Header files for development with %{name}.

#------------------------------------------------

%package -n	python3-%{name}
Summary:	Python 3 bindings for %{name}
Group:		Development/Python
%{?python_provide:%python_provide python3-%{name}}

%description -n	python3-%{name}
Python 3 bindings for Olm Double Ratchet cryptographic library.

#------------------------------------------------

%prep
%autosetup -p1

sed -e "s@/build@/%{_vpath_builddir}@g" -i python/olm_build.py

%build
%cmake -G Ninja \
    -DOLM_TESTS=OFF
%cmake_build

pushd python
%pyproject_wheel
popd

%check
pushd %{_vpath_builddir}
    ctest --output-on-failure
popd

%install
%cmake_install

pushd python
%pyproject_install
popd

%files -n %{libname}
%license LICENSE
%doc *.md *.rst docs/*.md
%{_libdir}/lib%{name}.so.%{major}{,.*}

%files -n %{develname}
%{_includedir}/%{name}/
%{_libdir}/lib%{name}.so
%{_libdir}/cmake/Olm/
%{_libdir}/pkgconfig/%{name}.pc

%files -n python3-%{name}
%{python_sitearch}/%{name}
%{python3_sitearch}/_lib%{name}.abi3.so
%{python3_sitearch}/python_%{name}-*.dist-info


%changelog
* Wed Jul 02 2025 umeabot <umeabot> 3.2.16-3.mga10
+ Revision: 2242891
- Mageia 10 Mass Rebuild
+ daviddavid <daviddavid>
- fix build with cmake 4.0

* Tue Mar 04 2025 wally <wally> 3.2.16-2.mga10
+ Revision: 2160405
- rebuild for python3.13

* Tue Dec 26 2023 daviddavid <daviddavid> 3.2.16-1.mga10
+ Revision: 2021791
- new version: 3.2.16
- switch to pyproject
- rebuild for py3.12

* Thu Sep 07 2023 squidf <squidf> 3.2.15-1.mga10
+ Revision: 1985004
- New version: 3.2.15

* Thu Dec 15 2022 luigiwalser <luigiwalser> 3.2.14-1.mga9
+ Revision: 1922733
- 3.2.14

* Mon Jul 25 2022 squidf <squidf> 3.2.12-1.mga9
+ Revision: 1871470
- New version: 3.2.12
- No test available

* Tue Mar 29 2022 umeabot <umeabot> 3.2.10-2.mga9
+ Revision: 1833360
- Mageia 9 Mass Rebuild

* Mon Feb 28 2022 mrambo3501 <mrambo3501> 3.2.10-1.mga9
+ Revision: 1786499
- verison 3.2.10
- rebuild for python-3.10

* Thu Dec 16 2021 neoclust <neoclust> 3.2.8-1.mga9
+ Revision: 1762281
- New version 3.2.8

* Thu Dec 16 2021 neoclust <neoclust> 3.2.3-2.mga9
+ Revision: 1762271
- Remove subrel on cauldon

* Thu Dec 16 2021 neoclust <neoclust> 3.2.3-1.1.mga9
+ Revision: 1762266
- Add P100: Fixes CVE-2021-44538 (mga#29773)

* Wed May 26 2021 daviddavid <daviddavid> 3.2.3-1.mga9
+ Revision: 1728332
- new version: 3.2.3

* Sat Mar 20 2021 daviddavid <daviddavid> 3.2.1-2.mga9
+ Revision: 1705304
- rebuild for python 3.9

* Wed Jan 13 2021 daviddavid <daviddavid> 3.2.1-1.mga8
+ Revision: 1671586
- initial package olm (needed for neochat)

